<script>
import { GlLabel } from '@gitlab/ui'
import interpretVariables from '@/assets/interpret-variables'

export default {
  name: 'MdDefinitionCard',
  components: { GlLabel },

  props: {
    item: {
      type: Object,
      required: true,
    },
  },

  computed: {
    definition() {
      const { item } = this

      return [
        {
          label: 'Service Name',
          value: `${item.service_name}`,
          type: 'value',
        },
        {
          label: 'Product group',
          value: `group::${item.product_group}`,
          type: 'GlLabel',
          props: { backgroundColor: '#6366F1' },
        },
        {
          label: 'Product categories',
          value: item.product_categories,
          type: 'GlLabelList',
          props: { backgroundColor: '#C5F4EC' },
        },
        {
          label: 'Category',
          value: interpretVariables(item.category),
          type: 'value',
        },
        {
          label: 'Action',
          value: interpretVariables(item.action),
          type: 'value',
        },
        {
          label: 'Label description',
          value: interpretVariables(item.label_description),
          type: 'value',
        },
        {
          label: 'Property description',
          value: interpretVariables(item.property_description),
          type: 'value',
        },
        {
          label: 'Value description',
          value: interpretVariables(item.value_description),
          type: 'value',
        },
        {
          label: 'Tiers',
          value: Array.isArray(item.tiers) ? item.tiers : [],
          type: 'TierLinks',
          props: { backgroundColor: '#FFE5E5' },
        },
        { label: 'Milestone', value: item.milestone },
        {
          label: 'Introduced by url',
          value: item.introduced_by_url,
          type: 'GlLink',
          props: { href: item.introduced_by_url },
        },
        {
          label: 'Extra values',
          value: item.extra_properties
            ? Object.entries(item.extra_properties)
            : null,
          type: 'object',
        },
      ]
    },
  },
}
</script>

<template>
  <div
    class="overflow-hidden rounded-lg bg-white shadow-md ring-1 ring-gray-200/50"
  >
    <div class="px-4 py-5">
      <h3
        class="break-all font-mono text-lg font-medium leading-6 text-gray-900"
      >
        <a :href="item.web_path">{{ item.key }}</a>
      </h3>
      <p class="m-0 max-w-prose text-sm text-gray-500 sm:mt-1">
        {{ item.description }}
      </p>
    </div>
    <div class="border-t border-gray-200 px-4 pt-5 pb-2">
      <dl class="sm:divide-y sm:divide-gray-200">
        <template v-for="property in definition">
          <div
            v-if="property.type === 'TierLinks'"
            :key="property.label"
            class="py-2.5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-4"
          >
            <dt class="text-sm font-medium text-gray-500">
              {{ property.label }}
            </dt>

            <dd class="m-0 sm:col-span-2">
              <template v-if="property.value.length">
                <span
                  v-for="labelTitle in property.value"
                  :key="labelTitle"
                  class="gl-pr-1"
                >
                  <gl-label
                    :background-color="property.props.backgroundColor"
                    :title="labelTitle"
                  />
                </span>
              </template>
              <span v-else class="text-gray-400">-</span>
            </dd>
          </div>
          <lazy-md-card-value v-else :key="property.label" :item="property" />
        </template>
      </dl>
    </div>
  </div>
</template>

<style>
.gl-label-link {
  pointer-events: none;
}
</style>
